﻿package microgames{
	
	import flash.display.Stage;
    import flash.events.Event;
    import flash.display.MovieClip;
	import flash.text.TextField
	
	public class MGLoader extends MovieClip {
		
		private var _stage:Stage;
		private var _root:MovieClip;
		private var _mc:MovieClip;
		private var _color:uint;
		private var _radius:uint;
		private var _txt:TextField;
		
		public function MGLoader(stage:Stage,root:MovieClip,color:uint) {
			trace("Loader start ...");
			this._radius 	= 50;
			this._stage 	= stage;
			this._root 		= root;
			this._color 	= color;
			this._mc 		= new MovieClip();
			this._mc.x 		= this._stage.stageWidth/2;
			this._mc.y 		= this._stage.stageHeight/2;
			this._root.addChild(this._mc);
			this._txt 		= new TextField();
			this._txt.selectable = false;
			this._txt.x 	= -20;
			this._txt.y 	= -10;
			this._mc.addChild(this._txt);
			this._stage.addEventListener(Event.ENTER_FRAME, _handleLoader);
		}
		private function _handleLoader(event:Event):void {
			var loaded:Number=this._stage.loaderInfo.bytesLoaded;
			var total:Number=this._stage.loaderInfo.bytesTotal;
			var percent:Number=Math.floor(loaded/total*100);
			trace(percent+"%");
			_updateProgress(percent);
			this._txt.htmlText 	= "<font align=\"center\" color=\"#333333\" face=\"verdana\"><b>"+percent+"%</b></font>";
			if (loaded>=total) {
				this._stage.removeEventListener(Event.ENTER_FRAME, _handleLoader);
				this._root.removeChild(this._mc);
				this._root.gotoAndPlay(2);
			}			
		}
		private function _updateProgress(percent:Number):void{
			this._mc.graphics.clear();
			this._mc.graphics.beginFill(this._color,1);
			var arc:Number = percent*3.6;
			var am:Number, bx:Number, by:Number, cx:Number, cy:Number;
			if (Math.abs(arc)>360) arc = 360;
			var s:Number = Math.ceil(Math.abs(arc)/45);
			var d:Number = -(arc/s/180)*Math.PI;
			var a:Number = -(-90/180)*Math.PI;
			if (s>0) {
				this._mc.graphics.lineTo(0, -this._radius);
				for (var i:Number = 0; i<s; i++) {
					a += d;
					am = a-(d/2);
					bx = Math.cos(a)*this._radius;
					by = -Math.sin(a)*this._radius;
					cx = Math.cos(am)*(this._radius/Math.cos(d/2));
					cy = -Math.sin(am)*(this._radius/Math.cos(d/2));
					this._mc.graphics.curveTo(cx, cy, bx, by);
				}
				this._mc.graphics.lineTo(x, y);
			}
			this._mc.graphics.endFill();
		}
	}
}